/*
Script: Set .LONGNAME EA for all files on given partition.
        Set a Jrescue EA too, to be able to detect and delete the 
        .LONGNAME EAs set by this script.
	Jrescue EA holds the path to the file. 
	Reports comsumed space, and the time it takes to run. 
	If a file is locked, so setln2 can't write the EA's, it tries
	to unlock the file (using unlock.exe included in eCS)
	Force option to owerwrite existing Jrescuer EA
        If dirname contains "lost+found", don't touch any files inside.
	autodetect all JFS drives on system, and put EA's on all

TODO:
	resque mode, that will search lost+found for files with
	Jrescuer EA and offer to move them to a subdir with 
	correct name.
*/

arg cmdline
del = pos('DELETE',cmdline)>0
debug = pos('DEBUG',cmdline)>0
resque = pos('RESQUE',cmdline)>0
force = pos('FORCE',cmdline)>0
all = pos('ALL',cmdline)>0

Parse upper arg path del1 debug1
/* path = arg(1) */
if path=='' then do
    say 'Usage:'
    say '    setln2 <drive:|all> [delete] [debug] [resque]'
    say '     '
    say '    drive:  the driveletter for the volume, ex C: '
    say '    all     Indicates that EAs should be set on all JFS volumes  '
    say '    delete  removes all longname EAs priviously set by this app '
    say '    debug   produces a _lot_ of output. Don''t use it '
    say '    all '
    say '    resque  doesn''t do anything yet :-) '
    say '     '
    say '     '
    exit 0
end

call rxFuncAdd "SysLoadFuncs" , "RexxUtil" , "SysLoadFuncs"
call SysLoadFuncs

if all then call useall del force

time1 = time('E')

info1 = SysDriveInfo(path)
PARSE VAR info1 drevbogstav1 free1 total1 label1
del = pos('DELETE',cmdline)>0
debug = pos('DEBUG',cmdline)>0
resque = pos('RESQUE',cmdline)>0
force = pos('FORCE',cmdline)>0
all = pos('ALL',cmdline)>0


If del 
  Then Say 'Resetting .LONGNAME EA on drive 'drevbogstav1
  Else Say 'Setting .LONGNAME EA on drive 'drevbogstav1

If force Then Say 'Forcing rewrite of path in EA'
If debug Then Say 'Too much debug info comming soon...'

if del then call processDel path debug
  else call processPath3 path debug force

info1 = SysDriveInfo(path)
PARSE VAR info1 drevbogstav2 free2 total2 label2

call SysSleep(1)
info1 = SysDriveInfo(path)
PARSE VAR info1 drevbogstav2 free2 total2 label2
SAY ' Freespace on 'drevbogstav1' changed: ' ( free1 - free2 ) % 1024 'KB'
time2 = time('E')
SAY 'Operation time:' STRIP(time2-time1,T,0) 'seconds'
exit 0

processdel: procedure
    Parse arg p debug
    LOST = 0
    num = 0
    numdel = 0
    rc1 = SysFileTree(p||'\*', file, "FOS")
    if rc1 > 0 then do
      Say 'Crash('rc1')' 
      exit rc1
      end
    do i=1 to file.0
	if pos('lost+found',file.i)>0 then do
	   lost = lost + 1
  	   iterate i
	end
	num = num + 1
        if debug then say 'processing: '||file.i
        rc = SysGetEA( file.i, "Jrescuer", "tmp" )
	if tmp \= "" then do
	    rc = SysPutEA(file.i, ".LONGNAME", "")
	    if rc==32 then do
 	      '@unlock' file.i ">nul"
  	      rc=SysPutEA(file.i, ".LONGNAME", "")
	      if debug then Say 'RC after unlock = 'rc' on 'file.i
	    end
            call SysPutEA file.i, "JRescuer", ""
	    numdel = numdel + 1
        end
    end
    Say ' '
    Say 'Deleted EAs in 'numdel' of' num 'Files'
    If lost >0 Then Say lost' files in lost+found not touched'
return

processPath3: procedure
    Parse arg p debug force
    num = 0
    numset = 0
    lost = 0
    unl = 0
    suc = 0
    forced = 0
    call SysFileTree p||'\*', 'file', 'FOS'
    if debug then SAY 'File.0' File.0
    do i=1 to file.0
	num = num + 1
	if pos('lost+found',file.i)>0 then do
	   lost = lost + 1
  	   iterate i
	end
        if debug then say 'processing: '||file.i 
        rc = SysGetEA( file.i, ".LONGNAME", "tmp" )
        if rc \= 0 | tmp==""  then do
            if debug then say 'Setting EA: '||file.i 'RC='rc
            name = FILESPEC( 'N', file.i )
	    path = FILESPEC( 'P', file.i )
	    jrtag = 'FDFF'x || d2c(length(path)) || '00'x || path 
	    if debug then say path '  'length(path)
            nameinfo = 'FDFF'x || d2c(length(name)) || '00'x || name
	    rc=SysPutEA(file.i,".LONGNAME",nameinfo)
	    if rc==32 then do
 	      '@unlock' file.i ">nul"
	      unl = unl + 1
  	      rc=SysPutEA(file.i,".LONGNAME",nameinfo)
	      if rc = 0 Then suc = suc + 1
	      if debug then Say 'RC after unlock = 'rc' on 'file.i
	    end
	    call SysPutEA file.i, "JRescuer", jrtag
	    numset = numset + 1
        end
	else if force Then do
	    rc = SysGetEA( file.i, "Jrescuer", "tmp" )
	    if rc==0 & length(tmp)>0 Then Do
	       path = FILESPEC( 'P', file.i )
	       jrtag = 'FDFF'x || d2c(length(path)) || '00'x || path 
	       call SysPutEA file.i, "JRescuer", jrtag
	       forced = forced + 1
	       end
	    end
	end
    Say ' '
    Say '.LONGNAME EAs set in 'numset' of' file.0 'files'
    if forced>0 Then Say 'Path EAs rewritten in 'forced' of 'file.0' files'
    if unl>0 Then Say 'Locked files: 'unl '  Sucessfully unlocked: ' suc
    If lost >0 Then Say lost' files in lost+found not touched'
return

useall: Procedure

parse arg del force
opt.includefs = "JFS"
opt.excludefs = "CDFS NTFS"
opt.lvmonly = 0

/* 1st: fetch a list of your local drives */
drvlist = SysDriveMap(, 'local')
/*SAY drvlist*/

/* 2rd: filter file systems */
drvlist = FSFilter(drvlist, opt.excludefs, opt.includefs)
/*SAY drvlist*/
If del Then SAY 'Going to reset .Longname EAs on the following volumes: 'drvlist
   else SAY 'Going to set .Longname EAs on the following volumes: 'drvlist

/* 3th: check which volumes are on the same physical disk */
lvminfo = ReadLVMInfo()
/*SAY lvminfo*/
jobs = 0
diskindex = ''
DO i = 1 TO WORDS(drvlist)
   drv = WORD(drvlist, i)
   p = WORDPOS(drv, lvminfo)
   IF p \= 0 THEN
      /* disk known */
      disk = WORD(lvminfo, p+1)
    ELSE IF opt.lvmonly THEN
      ITERATE
    ELSE
      disk = 'FF'x
   p = WORDPOS(disk, diskindex)
   IF p = 0 | disk = 'FF'x THEN DO /* no disk info defaults to a new job */
      /* new job */
      jobs = jobs +1
      job.jobs = drv
      diskindex = diskindex||disk' '
      END
    ELSE
      /* disk with other jobs */
      job.p = job.p' 'drv
   END



/* 4th: execute jobs in parallel */
/*SAY diskindex*/
DO i = 1 TO jobs
   disk = WORD(diskindex, i)
   IF disk = 'FF'x THEN
      disk = '(unknown)'
   CALL Execute job.i, disk, del, force
   END

EXIT 0
Return

Execute: PROCEDURE
   if ARG(3) Then s1 = ' DELETE' 
      else s1 = ' '
   if ARG(4) Then s1 = s1 'FORCE'
   SAY s1
   tmpfile = MyTmpFile('cdk?????.cmd')
   DO i = 1 TO WORDS(ARG(1))
      CALL LINEOUT tmpfile, 'call setln2 'WORD(ARG(1), i)s1
      END
   CALL LINEOUT tmpfile, 'pause'
   CALL LINEOUT tmpfile, 'del "'tmpfile'"' /* well, kicking off the file under cmd.exe's ass seems to work */
   CALL STREAM tmpfile, 'c', 'close'
   '@start /C "Setting .longname EA on 'ARG(2)'" /PGM "'tmpfile'"'
   RETURN

FSFilter: PROCEDURE
   ret = ''
   DO i = 1 TO WORDS(ARG(1))
      fs = SysFileSystemType(WORD(ARG(1), i))
      /*SAY WORD(ARG(1), i)': 'fs*/
      IF fs = '' THEN /* empty CD or whatever */
         ITERATE
      IF POS(fs, ARG(2)) = 0 & (ARG(3) = '' | POS(fs, ARG(3)) \= 0) THEN
         ret = ret||WORD(ARG(1), i)' '
      END
   RETURN ret

ReadLVMInfo: PROCEDURE
   tmpfile = MyTmpFile('lvm?????.tmp')
   IF tmpfile = '' THEN DO
      CALL LINEOUT STDERR, 'Failed to create temporary file.'
      RETURN ''
      END
   '@LVM /QUERY:VOLUMES >'tmpfile' 2>&1'
   ret = ''
   DO FOREVER
      l = LINEIN(tmpfile)
      IF STREAM(tmpfile, 's') \= 'READY' THEN
         LEAVE
      IF LEFT(l, 1) = ' ' THEN
         ITERATE
      DO FOREVER /* skip at least one line, but ignore drive lines without details */
         l2 = LINEIN(tmpfile)
         IF LEFT(l2, 1) = ' ' THEN
            LEAVE
         l = l2
         END
      drv = WORD(l, 1)
      l2 = LINEIN(tmpfile)
      disk = TRANSLATE(STRIP(SUBSTR(l2, 35), 'T'), 'FF'x, ' ') /* translate spaces to avoid confusion */
      ret = ret||drv' 'disk' '
      END
   CALL STREAM tmpfile, 'c', 'close'
   CALL SysFileDelete tmpfile
   RETURN ret

MyTmpFile: PROCEDURE
   path = VALUE('TEMP',,'OS2ENVIRONMENT')
   IF path \= '' & POS(RIGHT(path, 1), '\/') = 0 THEN
      path = path'\'
   RETURN SysTempFileName(path||ARG(1))

